/*
 * Copyright 2016 - 2025 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include "commands.hpp"

namespace nostalgia::gfx {

class UpdateSubSheetCommand: public TileSheetCommand {
	private:
		TileSheet &m_img;
		TileSheet::SubSheetIdx const m_idx;
		TileSheet::SubSheet m_sheet;

	public:
		UpdateSubSheetCommand(
				TileSheet &img,
				TileSheet::SubSheetIdx idx,
				ox::StringParam name,
				int cols,
				int rows);

		ox::Error redo() noexcept final;

		ox::Error undo() noexcept final;

		[[nodiscard]]
		int commandId() const noexcept final;

		[[nodiscard]]
		TileSheet::SubSheetIdx const &subsheetIdx() const noexcept override;

};

}